package SAE.ApiREST.WebService.service;
import SAE.ApiREST.WebService.model.Collect;

import java.util.ArrayList;
import java.util.List;

import SAE.ApiREST.WebService.model.Article;
import org.springframework.stereotype.Service;
import SAE.ApiREST.WebService.model.Collection;

@Service
public class StubCollectionService implements ICollectionService {
    private ArrayList<Collect> collections;
    public List<Collect> getAllCollections() {
        return this.collections;
    }

    // region Collection

    // region GET
    public Collect getCollectionById(long isbn){
        for(Collect collection : this.collections){
            if(collection.getId() == isbn) {
                return collection;
            }
        }
        return null;
    }

    @Override
    public List<Collection> getAllCollectionsByName(String name){
        private ArrayList<Collection> repCollections = new ArrayList<Collection>();
        for(Collection collection : this.collections){
            if(collection.getName() == name) {
    public List<Collect> getAllCollectionsByName(String name){
        ArrayList<Collect> repCollections = new ArrayList<Collect>();
        for(Collect collection : this.collections){
            if(collection.getName() == name) {
                repCollections.add(collection);
            }
        }
        return repCollections;
    }
    // endregion

    // region DELETE
    @Override
    public void deleteColletionById(long isbn){
        Collect collection = getCollectionById(isbn);
        this.collections.remove(collection);
    }

    @Override
    public void deleteColletionByName(String name){
        List<Collect> collectionsByName = getAllCollectionsByName(name);
        this.collections.remove(collectionsByName.get(0));
    }

    @Override
    public void deleteAllColletionByName(String name){
        List<Collect> collectionsByName = getAllCollectionsByName(name);
        this.collections.removeAll(collectionsByName);
    }

    @Override
    public void addCollection(Collect collection) {
            this.collections.add(collection);
    }
    // endregion

    // region PUT
    public void addCollections(List<Collect> collections){
        this.collections.addAll(collections);
    }
    // endregion

    // region POST
    public void modifyCollectionName(Collect collection, String name){
        collection.setName(name);
    }

    @Override
    public void modifyCollectionNameById(long isbn, String name){
        Collect collection = getCollectionById(isbn);
        modifyCollectionName(collection,name);
    }
    // endregion
    // endregion

    // region Article
    public List<Article> getAllArticles(Collect collect){
        return collect.getAllArticles();
    }
    public void addArticle(Collect collect, Article article){
        collect.addArticle(article);
    }
    public void deleteArticle(Collect collect, Article article){
        collect.removeArticle(article);
    }
    //  endregion
}